/*
 *  Segreteria.h
 *  
 *  Author: G. Ianni
 *  Si ringrazia Gennaro Frazzingaro per la trascrizione.
 * 
 *
 */

#include <JTC/jtc.h>

//Esame 30/03/04

class Segreteria : public JTCMonitor
{
	bool occupato[2];		//A = 0, B = 1
	int numDisabili;	//numero di disabili in attesa
	int cercaLibero()
	{
		if (occupato[1]) // cerca di occupare preferenzialmente B
			return 0;	
		else return 1;
	}
public:
	int prendiSportello(bool disabile)
	{
		JTCSynchronized sync(*this);
		while(!disabile && ((occupato[0] && occupato[1]) || (occupato[1] && numDisabili > 0)) || 
			 (disabile && (occupato[0] && occupato[1])))
			wait();
		if(disabile)
			numDisabili--;
		int a = cercaLibero();
		occupato[a] = true;
		return a;
	}
	void lasciaSportello(int numSportello)
	{
		JTCSynchronized sync(*this);
		occupato[numSportello] = false;
		notifyAll();
	}
};	
void main()
{
	JTCInitialize init;
	// ...
}